Index: flexpart_code/grib2nc4/README
===================================================================
--- flexpart_code/grib2nc4/README	(revision 496c6079149f12fbb3e7ecf1f351470794679655)
+++ flexpart_code/grib2nc4/README	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -7,5 +7,5 @@
          M. Harustak
 
-Last Update: 29 May 2016
+Last Update: 05 July 2017
 
 ======================================================================
@@ -19,4 +19,8 @@
 data for computations.  It then takes the data which has been stored in
 FLEXPART global arrays and selectively writes it to a NetCDF4 file.
+
+Optional parameter allows user to request arrays calculated for specified
+location instead of default algorithm selecting lowest left corner of meteorological
+domain with a surface pressure above 100000Pa.
 
 This distribution is integrated into the FLEXPART source code, in a grib2nc4
@@ -42,4 +46,12 @@
 is good, but only whether data was stored correctly in the NC4 files.
 
+To be able to quickly compare variables in NetCDF files, simple utility
+nc4cmp was introduced. It compares specified variable in two NetCDF files
+(with dimension up to 3) and it prints average and maximal difference between
+the values. It allows for specification of optional tolerance (in %).
+Difference is calculated as abs((value1-value2)/value1)*100.
+It is calculated for all values of variable multidimensional array.
+
+
 ======================================================================
 2. Quick-Start
@@ -64,4 +76,6 @@
 Simply type "make" (noting that you may see some warnings related to
 variables for nests) to produce grib2nc4.
+
+NetCDF compare utility nc4cmp can be built using command "make nc4cmp".
 
 Before trying to run, you might want to try "make test" to make sure that
@@ -81,4 +95,9 @@
 as the second argument.
 
+Usage:
+
+  ./grib2nc4 <inpath> <outpath> [lat=value lon=value] [optional varnames]
+
+
 Sample usage:
 
@@ -92,4 +111,27 @@
 
   ./grib2nc4 GD15051200 def9_nc1p0.nc4  q  w
+
+Calculation at user specified location can be requested by adding coord parameter
+to the command line:
+
+  ./grib2nc4 GD15051200 def9_nc1p0.nc4 lon=20 lat=45
+
+To compare two NetCDF files, nc4cmp can be used.
+
+Usage:
+
+  ./nc4cmp <file1> <file2> <variable> [optional tolerance in %]
+
+Sample usage:
+
+  ./nc4cmp def9_nc1p0.nc4 def9_nc1p0_reference.nc4 U
+
+Sample usage with tolerance 1%:
+
+  ./nc4cmp def9_nc1p0.nc4 def9_nc1p0_reference.nc4 U 1.0
+
+This will extract variable U from both NetCDF files, print and compare dimensions,
+compare values and print average and maximal difference.
+
 
 ======================================================================
Index: flexpart_code/grib2nc4/fp2nc4io_mod.F90
===================================================================
--- flexpart_code/grib2nc4/fp2nc4io_mod.F90	(revision 87d96843f7f85bb599c0f7cdfb7f1f42731b9eaf)
+++ flexpart_code/grib2nc4/fp2nc4io_mod.F90	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -157,4 +157,7 @@
         ncfunc_retval = nf90_def_var(ncid, 'height', NF90_DOUBLE, &
 &                                    z_dimid, varid)
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","height of the FLEXPART model levels")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","m a.g.l")
 
         ncfunc_retval = nf90_def_var_deflate(ncid, varid,   &
@@ -169,13 +172,29 @@
         ncfunc_retval = nf90_def_var(ncid, 'dx', NF90_DOUBLE, varid)
         ncfunc_retval = nf90_put_var(ncid, varid, dx)
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","grid distance in x direction")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","degrees")
+
 
         ncfunc_retval = nf90_def_var(ncid, 'dy', NF90_DOUBLE, varid)
         ncfunc_retval = nf90_put_var(ncid, varid, dy)
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","grid distance in y direction")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","degrees")
+
 
         ncfunc_retval = nf90_def_var(ncid, 'xlon0', NF90_DOUBLE, varid)
         ncfunc_retval = nf90_put_var(ncid, varid, xlon0)
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","longitude of the lowest left corner")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","degrees")
+
 
         ncfunc_retval = nf90_def_var(ncid, 'ylat0', NF90_DOUBLE, varid)
         ncfunc_retval = nf90_put_var(ncid, varid, ylat0)
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","latitude of the lowest left corner")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","degrees")
+
 
         ! All done, close the NetCDF file
@@ -296,16 +315,40 @@
             ncfunc_retval = nf90_put_var(ncid, varid, &
 &                                        uu(0:nx-1, 0:ny-1, 1:nz, 1))
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","U component of wind in the X[horizontal] direction")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","m s**-1")
+
+
         ELSEIF (nc_varname == 'V') THEN
             ncfunc_retval = nf90_put_var(ncid, varid, &
 &                                        vv(0:nx-1, 0:ny-1, 1:nz, 1))
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","V component of wind in the Y[horizontal] direction")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","m s**-1")
+
+
         ELSEIF (nc_varname == 'T') THEN
             ncfunc_retval = nf90_put_var(ncid, varid, &
 &                                        tt(0:nx-1, 0:ny-1, 1:nz, 1))
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","temperature")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","k")
+
         ELSEIF (nc_varname == 'W') THEN
             ncfunc_retval = nf90_put_var(ncid, varid, &
 &                                        ww(0:nx-1, 0:ny-1, 1:nz, 1))
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","wind component in the Z[vertical] direction")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units","m s**-1")
+
+
         ELSEIF (nc_varname == 'Q') THEN
             ncfunc_retval = nf90_put_var(ncid, varid, &
 &                                        qv(0:nx-1, 0:ny-1, 1:nz, 1))
+! attributes
+            ncfunc_retval = nf90_put_att(ncid, varid, "description","specific humidity")
+            ncfunc_retval = nf90_put_att(ncid, varid, "units"," ")
+
+
         ELSE
             PRINT *,
Index: flexpart_code/grib2nc4/grib2nc4.F90
===================================================================
--- flexpart_code/grib2nc4/grib2nc4.F90	(revision 496c6079149f12fbb3e7ecf1f351470794679655)
+++ flexpart_code/grib2nc4/grib2nc4.F90	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -11,4 +11,9 @@
     !        May 2016                                                        *
     !*************************************************************************
+   !   M. Harustak                                                          *
+   !   -) modification to generate the output in single precission          *
+   !   -) possibility to add a lat lon selection to obtain the met variables*
+   !      in the vertical levels defined in that location                   *
+   !*************************************************************************
 
     USE par_mod
@@ -21,11 +26,12 @@
     IMPLICIT NONE
 
-    LOGICAL :: metfile_exists   
+    LOGICAL :: metfile_exists, coordinates_provided, lat_provided, lon_provided
     INTEGER :: i, j, k
     INTEGER :: num_optional_vars, num_vars
     INTEGER, PARAMETER :: DEFLATE_LEVEL = 2  ! Compression level (0-9)
-    CHARACTER(LEN=512) :: met_filepath, netcdf4_filepath
+    CHARACTER(LEN=512) :: met_filepath, netcdf4_filepath, param_str, coord_name_str, coord_val_str
     CHARACTER, DIMENSION(:), ALLOCATABLE :: vars_list  ! list of variables
-    
+    INTEGER :: coordX, coordY, stat
+    REAL :: coord_lat, coord_lon
     INTEGER :: metdata_format = UNKNOWN_METDATA  ! From FP par_mod
 
@@ -34,5 +40,5 @@
     ! Read in mandatory arguments
     IF (IARGC() < 2) THEN
-        PRINT *, 'Usage: grib2netcdf4 <inpath> <outpath> [optional varnames]'
+        PRINT *, 'Usage: grib2netcdf4 <inpath> <outpath> [lon=X lat=Y] [optional varnames]'
         STOP
     ELSE
@@ -48,21 +54,45 @@
     ! First, get the number of optional args and allocate vars_list,
     ! and fill the first three elements
-    IF (IARGC() > 2) THEN
-        num_optional_vars = IARGC() - 2
-    ELSE
-        num_optional_vars = 0
-    ENDIF
+    coordinates_provided = .FALSE.
+    lat_provided = .FALSE.
+    lon_provided = .FALSE.
+    ALLOCATE( vars_list(IARGC()+3),stat=stat )
 
-    num_vars = num_optional_vars + 3
-    ALLOCATE( vars_list(num_vars) )
     vars_list(1) = 'u'
     vars_list(2) = 'v'
     vars_list(3) = 't'
         
-    ! Read in optional variable arguments, starting at element 4 of vars_list
-    IF (IARGC() > 2) THEN
-        DO i=1,num_optional_vars
-            CALL GETARG( i+2, vars_list(i+3) )
-        ENDDO 
+    num_vars = 3
+    DO i=3,IARGC()
+        CALL GETARG(i,param_str)
+        param_str = TRIM(param_str)
+        j = SCAN(param_str,"=")
+        if (j>1) then
+            coord_name_str=param_str(1:j-1)
+            coord_val_str=param_str(j+1:)
+            IF ( coord_name_str == "lat" .or. coord_name_str == "LAT" ) THEN
+                read(coord_val_str,*,iostat=stat) coord_lat
+                if ( stat == 0 ) then
+                    lat_provided = .TRUE.
+                else
+                    print *, "Incorrect coordinates: ", coord_val_str
+                    stop
+                endif
+            ELSE IF ( coord_name_str == "lon" .or. coord_name_str == "LON" ) THEN
+                read(coord_val_str,*,iostat=stat) coord_lon
+                if ( stat == 0 ) then
+                    lon_provided = .TRUE.
+                else
+                    print *, "Incorrect coordinates: ", coord_val_str
+                    stop
+                endif
+            ENDIF
+        else
+            num_vars = num_vars + 1
+            vars_list(num_vars) = param_str
+        endif
+    ENDDO
+    IF (lat_provided .AND. lon_provided) THEN
+        coordinates_provided = .TRUE.
     ENDIF
 
@@ -126,6 +156,16 @@
     !CALL gridcheck_nests
 
+    ! If the coordinates are provided, then we need to obtain
+    !  the corresponding grid indexes since this is what verttransform needs
+    if ( coordinates_provided ) then
+        coordX = (coord_lon-xlon0)/dx
+        coordY = (coord_lat-ylat0)/dy
+        print *, "Coordinates: "
+        print *, "lon: ", coord_lon, ", lat: ",coord_lat
+        print *, "x: ", coordX, ", y: ", coordY
+    endif
+
     PRINT *, 'Calling processmetfields()...'
-    call processmetfields( 1, metdata_format)
+    call processmetfields( 1, metdata_format, coordinates_provided, coordX, coordY)
 
     PRINT *, 'Calling fp2nc4io_dump()...'
Index: flexpart_code/grib2nc4/nc4cmp.F90
===================================================================
--- flexpart_code/grib2nc4/nc4cmp.F90	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
+++ flexpart_code/grib2nc4/nc4cmp.F90	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -0,0 +1,244 @@
+PROGRAM nc4cmp
+
+    !*************************************************************************
+    !  This program compares variable in two NetCDF files                    *
+    ! (with dimension up to 3) and it prints average and maximal difference  *
+    ! between the values. It allows for specification of optional tolerance  *
+    !                                                                        *
+    ! Usage:                                                                 *
+    !                                                                        *
+    !     ./nc4cmp <file1> <file2> <variable> [optional tolerance in %]      *
+    !                                                                        *
+    !        M. Harustak                                                     *
+    !                                                                        *
+    !        March 2017                                                      *
+    !*************************************************************************
+
+
+    USE netcdf
+
+    IMPLICIT NONE
+
+    LOGICAL :: file1_exists, file2_exists
+    CHARACTER(LEN=512) :: file1, file2, precision_str, variable
+    CHARACTER(LEN=NF90_MAX_NAME) :: returned_name
+    REAL :: tolerance
+    INTEGER :: ncid, varid, retval, xtype, numDims1, numDims2, i, j, k, stat
+    INTEGER, dimension(NF90_MAX_VAR_DIMS) :: varDimIDs1, varDimIDs2, dims1, dims2
+    double precision :: variable_array_0d_1, variable_array_0d_2
+    double precision, allocatable, dimension(:) :: variable_array_1d_1, variable_array_1d_2 
+    double precision, allocatable, dimension(:,:) :: variable_array_2d_1, variable_array_2d_2
+    double precision, allocatable, dimension(:,:,:) :: variable_array_3d_1, variable_array_3d_2
+    double precision :: v1, v2
+    double precision :: sum_diff, max_diff
+    integer :: count_diff
+    logical :: different = .FALSE.
+
+    ! Read in mandatory arguments
+    IF (IARGC() < 3) THEN
+        PRINT *, 'Usage: nc4cmp <file1> <file2> <variable> [optional tolerance in %]'
+        STOP
+    ELSE
+        CALL GETARG(1, file1) 
+        CALL GETARG(2, file2) 
+        CALL GETARG(3, variable)
+    ENDIF
+
+    IF (IARGC() > 3) THEN
+        CALL GETARG( 4, precision_str)
+        READ(precision_str, '(f10.5)') tolerance
+    ELSE
+        tolerance = 0
+    ENDIF
+    print *,"Tolerance ",tolerance,"%"
+
+    INQUIRE( FILE=file1, EXIST=file1_exists )
+    IF ( file1_exists ) THEN
+        PRINT *, 'File 1: ', TRIM(file1)
+    ELSE
+        PRINT *, 'Unable to find file: ', TRIM(file1)
+        STOP
+    ENDIF
+    INQUIRE( FILE=file2, EXIST=file2_exists )
+    IF ( file2_exists ) THEN
+        PRINT *, 'File 2: ', TRIM(file2)
+    ELSE
+        PRINT *, 'Unable to find file: ', TRIM(file2)
+        STOP
+    ENDIF
+
+    print *, "Opening ",TRIM(file1)," for reading"
+    retval = nf90_open(file1, NF90_NOWRITE, ncid)
+    retval = nf90_inq_varid(ncid, TRIM(variable) , varid)
+    retval = nf90_inquire_variable(ncid, varid, ndims = numDims1, dimids = varDimIDs1)
+    print *, "Reading variable ",TRIM(variable), ", no of dimensions: ",numDims1
+    do i=1,numDims1
+        retval = nf90_inquire_dimension(ncid, varDimIDs1(i),len=j)
+        dims1(i) = j
+        print *,"  - dimension ",i,": ", j
+    enddo
+    if ( numDims1 == 0) then
+        retval = nf90_get_var(ncid, varid, variable_array_0d_1)
+    else if ( numDims1 == 1) then
+        allocate(variable_array_1d_1(dims1(1)),stat=stat)
+        retval = nf90_get_var(ncid, varid, variable_array_1d_1)
+    else if ( numDims1 == 2) then
+        allocate(variable_array_2d_1(dims1(1),dims1(2)),stat=stat)
+        retval = nf90_get_var(ncid, varid, variable_array_2d_1)
+    else if ( numDims1 == 3) then
+        allocate(variable_array_3d_1(dims1(1),dims1(2),dims1(3)),stat=stat)
+        retval = nf90_get_var(ncid, varid, variable_array_3d_1)
+    endif
+    retval = nf90_close(ncid)
+    print *, "...done"
+
+    print *, "Opening ",TRIM(file2)," for reading"
+    retval = nf90_open(file2, NF90_NOWRITE, ncid)
+    retval = nf90_inq_varid(ncid, TRIM(variable) , varid)
+    retval = nf90_inquire_variable(ncid, varid, ndims = numDims2, dimids = varDimIDs2)
+    print *, "Reading variable ",TRIM(variable), ", no of dimensions: ",numDims2
+    do i=1,numDims2
+        retval = nf90_inquire_dimension(ncid, varDimIDs2(i),len=j)
+        dims2(i) = j 
+        print *,"  - dimension ",i,": ", j
+    enddo
+    if ( numDims2 == 0) then
+        retval = nf90_get_var(ncid, varid, variable_array_0d_2)
+    else if ( numDims2 == 1) then
+        allocate(variable_array_1d_2(dims2(1)),stat=stat)
+        retval = nf90_get_var(ncid, varid, variable_array_1d_2)
+    else if ( numDims2 == 2) then
+        allocate(variable_array_2d_2(dims2(1),dims2(2)),stat=stat)
+        retval = nf90_get_var(ncid, varid, variable_array_2d_2)
+    else if ( numDims2 == 3) then
+        allocate(variable_array_3d_2(dims2(1),dims2(2),dims2(3)),stat=stat)
+        retval = nf90_get_var(ncid, varid, variable_array_3d_2)
+    endif
+    retval = nf90_close(ncid)
+    print *, "...done"
+
+    if (numDims1 /= numDims2) THEN
+        print *, "Number of dimensions differs..."
+        STOP
+    endif
+    do i=1,numDims1
+        if (dims1(i) /= dims2(i)) then
+            print *, "Dimension ",i," differs..."
+            STOP
+        endif
+    enddo
+
+    if (numDims1>3) then
+        print *,"Only up to 3 dimensions supported..." 
+        STOP
+    endif
+
+    sum_diff = 0.0
+    count_diff = 0
+
+    if (numDims1==0) then
+        v1 = variable_array_0d_1
+        v2 = variable_array_0d_2
+        print *, "Value 1: ",v1
+        print *, "Value 2: ",v2
+        if ( ( v1 == 0 .AND. v2 /= 0 ) .OR. ( v1 /= 0 .AND. v2 == 0 ) ) then
+            print *," === variables differ ==="
+            STOP
+        else if ( v1 == 0 .AND. v2 == 0) then
+            print *," === variables are within tolerance ==="
+            STOP
+        else if ( abs((v1-v2)/v1*100) > tolerance ) then 
+            print *," === variables differ ==="
+            STOP
+        else 
+            print *," === variables are within tolerance ==="
+            STOP
+        endif
+    endif
+    if (numDims1==1) then
+        do i=1,dims1(1)
+            v1 = variable_array_1d_1(i)
+            v2 = variable_array_1d_2(i)
+            if ( ( v1 == 0 .AND. v2 /= 0 ) .OR. ( v1 /= 0 .AND. v2 == 0 ) ) then
+                different = .TRUE. 
+            else if (v1/=0 .AND. v2/=0 .AND. abs((v1-v2)/v1*100) > tolerance ) then
+                different = .TRUE.
+            endif
+            if ( v1 /= 0) then 
+                sum_diff = sum_diff+abs((v1-v2)/v1*100)
+                count_diff = count_diff+1
+                if (abs((v1-v2)/v1*100)>max_diff) then
+                    max_diff=abs((v1-v2)/v1*100)
+                endif
+            endif
+        enddo
+        if ( different ) then
+            print *," === variables differ ==="
+        else
+            print *," === variables are within tolerance ==="
+        endif
+        print *," === avg(diff%): ", sum_diff/count_diff
+        print *," === max(diff%): ",max_diff
+        STOP
+    endif
+    if (numDims1==2) then
+        do i=1,dims1(1)
+            do j=1,dims1(2)
+                v1 = variable_array_2d_1(i,j)
+                v2 = variable_array_2d_2(i,j)
+                if ( ( v1 == 0 .AND. v2 /= 0 ) .OR. ( v1 /= 0 .AND. v2 == 0 ) ) then
+                    different = .TRUE.
+                else if (v1/=0 .AND. v2/=0 .AND. abs((v1-v2)/v1*100) > tolerance ) then
+                    different = .TRUE.
+                endif
+                if (v1/=0) then
+                    sum_diff = sum_diff+abs((v1-v2)/v1*100)
+                    count_diff = count_diff+1
+                    if (abs((v1-v2)/v1*100)>max_diff) then
+                        max_diff=abs((v1-v2)/v1*100)
+                    endif
+                endif
+            enddo
+        enddo
+        if ( different ) then
+            print *," === variables differ ==="
+        else
+            print *," === variables are within tolerance ==="
+        endif
+        print *," === avg(diff%): ", sum_diff/count_diff
+        print *," === max(diff%): ",max_diff
+        STOP
+    endif
+    if (numDims1==3) then
+        do i=1,dims1(1)
+            do j=1,dims1(2)
+                do k=1,dims1(3)
+                    v1 = variable_array_3d_1(i,j,k)
+                    v2 = variable_array_3d_2(i,j,k)
+                    if ( ( v1 == 0 .AND. v2 /= 0 ) .OR. ( v1 /= 0 .AND. v2 == 0 ) ) then
+                        different = .TRUE.
+                    else if (v1/=0 .AND. v2/=0 .AND. abs((v1-v2)/v1*100) > tolerance ) then
+                        different = .TRUE.
+                    endif
+                    if (v1/=0) then
+                        sum_diff = sum_diff+abs((v1-v2)/v1*100)
+                        count_diff = count_diff+1
+                        if (abs((v1-v2)/v1*100)>max_diff) then
+                            max_diff=abs((v1-v2)/v1*100)
+                        endif
+                    endif
+                enddo
+            enddo
+        enddo
+        if ( different ) then
+            print *," === variables differ ==="
+        else
+            print *," === variables are within tolerance ==="
+        endif
+        print *," === avg(diff%): ", sum_diff/count_diff
+        print *," === max(diff%): ",max_diff
+        STOP
+    endif
+
+
+END PROGRAM nc4cmp
Index: flexpart_code/grib2nc4/processmetfields.F90
===================================================================
--- flexpart_code/grib2nc4/processmetfields.F90	(revision 496c6079149f12fbb3e7ecf1f351470794679655)
+++ flexpart_code/grib2nc4/processmetfields.F90	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -1,3 +1,4 @@
-subroutine processmetfields(ind,metdata_format)
+subroutine processmetfields(ind,metdata_format,coordinates_provided, coordX, coordY)
+
   !                       i     o
   !*****************************************************************************
@@ -37,4 +38,6 @@
   integer :: dumpData
   character(len=512):: fpfname, dumpPath, filename
+  integer :: coordX, coordY
+  logical :: coordinates_provided
 
 
@@ -107,5 +110,9 @@
              call calcpar_ecmwf(memind(1),uuh,vvh,pvh) 
              call calcpar_nests(memind(1),uuhn,vvhn,pvhn,metdata_format)
-             call verttransform_ecmwf(memind(1),uuh,vvh,wwh,pvh)
+             if ( coordinates_provided ) then
+                 call verttransform_grib2nc4_ecmwf(memind(1),uuh,vvh,wwh,pvh,coordX,coordY)
+             else
+                 call verttransform_grib2nc4_ecmwf(memind(1),uuh,vvh,wwh,pvh,-1,-1)
+             endif
              call verttransform_nests(memind(1),uuhn,vvhn,wwhn,pvhn)
              memtime(1)=wftime(ind)
@@ -116,5 +123,9 @@
              call calcpar_gfs(memind(1),uuh,vvh,pvh)
              call calcpar_nests(memind(1),uuhn,vvhn,pvhn,metdata_format)
-             call verttransform_gfs(memind(1),uuh,vvh,wwh,pvh)
+             if ( coordinates_provided ) then
+                 call verttransform_grib2nc4_gfs(memind(1),uuh,vvh,wwh,pvh,coordX,coordY)
+             else
+                 call verttransform_grib2nc4_gfs(memind(1),uuh,vvh,wwh,pvh,-1,-1)
+             endif
              call verttransform_nests(memind(1),uuhn,vvhn,wwhn,pvhn)
              memtime(1)=wftime(ind)
